﻿-- Author      : Administrator
-- Create Date : 9/10/2008 6:44:47 PM
SLICECMDR = { };
SLICECMDR.AlertPending = 0;
SLICECMDR.curCombo = 0;
SLICECMDR.LastTime = 0;
SLICECMDR.BarFont = 0;
SLICECMDR.LastEnergy = 0;
SLICECMDR.RupExpires = 0;
SLICECMDR.DPExpires = 0;
SLICECMDR.SliceExpires = 0;
SLICECMDR.HungerExpires = 0;
SLICECMDR.LastSliceExpire = 0;
SLICECMDR.tNow = 0;

-- fade
local fadein = 0.5       -- fade delay for each combo point frame
local fadeout = 0.5      -- fade delay for each combo point frame
local framefadein = 0.2  -- fade delay for entering combat
local framefadeout = 0.2 -- fade delay for leaving combat
local scaleUI = 0
local widthUI = 0

SLICECMDR.BARS = { 
	['CP'] = {
		['obj'] = 0
	},
	['HfB'] = {
		['obj'] = 0,
		['Expires'] = 0,
		['AlertPending'] = 0
	},
	['SnD'] = {
		['obj'] = 0,
		['Expires'] = 0
	},
	['DP'] = {
		['obj'] = 0,
		['Expires'] = 0
	},
	['Rup'] = {
		['obj'] = 0,
		['Expires'] = 0
	},
};

function SliceCmdr_MoveStart()
	if (SliceCmdr_Save.IsLocked == false) then
		SliceCmdr:StartMoving();
	 end
end

function SliceCmdr_MoveStop()
	if (SliceCmdr_Save.IsLocked == false) then
		SliceCmdr:StopMovingOrSizing();
	end		
end

function SliceCmdr_BarTexture() 
	if (SliceCmdr_Save.BarTexture) then
		return SliceCmdr_BarTextures[ SliceCmdr_Save.BarTexture ];
	else
		return "Interface\\AddOns\\SliceCommander\\Images\\Smooth.tga";
	end
	
end

function SliceCmdr_SoundTest(name) 
	if (SliceCmdr_Sounds[name]) then
		PlaySoundFile( SliceCmdr_Sounds[name] );
	end
end

function SliceCmdr_Sound(saved) 
	if (SliceCmdr_Save[saved]) then
		PlaySoundFile( SliceCmdr_Sounds[ SliceCmdr_Save[saved] ] );
	end
end

function SliceCmdr_ChangeAnchor()
	local LastAnchor = VTimerEnergy;
	local offSetSize = SliceCmdr_Save.BarMargin; -- other good values, -1, -2
	
	-- CP Bar --
	SLICECMDR.BARS['CP']['obj']:SetPoint("BOTTOMLEFT", LastAnchor, "TOPLEFT", 0, offSetSize);
	
	-- Slice and dice --
	if (SLICECMDR.SliceExpires ~= 0) then
		SLICECMDR.BARS['SnD']['obj']:SetPoint("TOPLEFT", LastAnchor, "BOTTOMLEFT", 0, -1 * offSetSize);
		LastAnchor = SLICECMDR.BARS['SnD']['obj'];
	end
	
	-- rupture --
	if (SLICECMDR.RupExpires ~= 0) then
		SLICECMDR.BARS['Rup']['obj']:SetPoint("TOPLEFT", LastAnchor, "BOTTOMLEFT", 0, -1 * offSetSize);
		LastAnchor = SLICECMDR.BARS['Rup']['obj'];
	end
	
	-- hunger for blood --
	if (SLICECMDR.HungerExpires ~= 0) then
		SLICECMDR.BARS['HfB']['obj']:SetPoint("TOPLEFT", LastAnchor, "BOTTOMLEFT", 0, -1 * offSetSize);
		LastAnchor = SLICECMDR.BARS['HfB']['obj'];
	end
	
	-- deadly poison --
	if (SLICECMDR.DPExpires ~= 0) then
		SLICECMDR.BARS['DP']['obj']:SetPoint("TOPLEFT", LastAnchor, "BOTTOMLEFT", 0, -1 * offSetSize);
		LastAnchor = SLICECMDR.BARS['DP']['obj'];
	end
	
end

function SliceCmdr_OnEvent(self, event, ...)
	if (event == "COMBAT_LOG_EVENT_UNFILTERED") then
		local timestamp, type, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags = select(1, ...);
		if (type == "SPELL_AURA_REFRESH" or type == "SPELL_AURA_APPLIED" or type == "SPELL_AURA_REMOVED" or type == "SPELL_AURA_APPLIED_DOSE" or type == "SPELL_PERIODIC_AURA_REMOVED" or type == "SPELL_PERIODIC_AURA_APPLIED" or type == "SPELL_PERIODIC_AURA_APPLIED_DOSE" or type == "SPELL_PERIODIC_AURA_REFRESH") then
			local spellId, spellName, spellSchool = select(9, ...);
			
			if (destName == UnitName("player")) then
				if (spellName == SC_SPELL_SND) then
					if (type == "SPELL_AURA_REMOVED") then
						if (UnitAffectingCombat("player")) then
							SliceCmdr_Sound("Fail");
						else
							SliceCmdr_Sound("Expire");
						end					
						SLICECMDR.SliceExpires = 0;
						SliceCmdr_ChangeAnchor();
						SLICECMDR.BARS['SnD']['obj']:Hide();
					else
						local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitAura("player", SC_SPELL_SND);
						local timeLeftOnLast = SLICECMDR.SliceExpires - GetTime();
						SLICECMDR.BARS['SnD']['obj']:Show();
						SLICECMDR.SliceExpires = expirationTime;
						SliceCmdr_ChangeAnchor();--change les ancres des bares
						if (type == "SPELL_AURA_APPLIED") then
							SliceCmdr_Sound("Applied");
						else
							if (timeLeftOnLast <= 1) then
								SliceCmdr_Sound("Apply1");
							else
								if (timeLeftOnLast <= 2) then
									SliceCmdr_Sound("Apply2");
								else
									SliceCmdr_Sound("Apply3");
								end
							end
						end
					end
				end
				
				-- HUNGER FOR BLOOD EVENT --
				if (spellName == SC_SPELL_HFB) then
					if (type == "SPELL_AURA_REMOVED") then
						SLICECMDR.HungerExpires = 0;
						SLICECMDR.BARS['HfB']['Expires'] = 0;
						SliceCmdr_ChangeAnchor();--change les ancres des bares
						SLICECMDR.BARS['HfB']['obj']:Hide();
						if (UnitAffectingCombat("player")) then
							SliceCmdr_Sound("HfB.Fail");
						else
							SliceCmdr_Sound("HfB.Expire");
						end
					else
						local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitAura("player", SC_SPELL_HFB);
						local timeLeftOnLast = SLICECMDR.HungerExpires - GetTime();
						SLICECMDR.HungerExpires = expirationTime;
						SLICECMDR.BARS['HfB']['Expires'] = expirationTime;
						if (type == "SPELL_AURA_APPLIED") then
							SliceCmdr_Sound('HfB.Applied');
						else
							if (timeLeftOnLast <= 1) then
								SliceCmdr_Sound('HfB.Refresh1');
							else
								if (timeLeftOnLast <= 2) then
									SliceCmdr_Sound('HfB.Refresh2');
								else
									SliceCmdr_Sound('HfB.Refresh3');
								end
							end							
						end
						
						SLICECMDR.BARS['HfB']['obj']:Show();
						SliceCmdr_ChangeAnchor();--change les ancres
					end
				end
			else
				if (destName == UnitName("target")) then
					-- DEADLY POISON --
					if (spellName == SC_SPELL_DP and SliceCmdr_Save.DPBarShow == true) then
						local name1, rank1, icon1, count1, debuffType1, duration1, expirationTime1, isMine1, isStealable1 = UnitDebuff("target", SC_SPELL_DP);
						
						if (type == "SPELL_AURA_REMOVED") then
							--SLICECMDR.DPExpires = 0;
							--SLICECMDR.BARS['DP']['Expires'] = 0;
							--SLICECMDR.BARS['DP']['obj']:Hide();
							--SliceCmdr_ChangeAnchor();--change les ancres
						else
							if (isMine1 == "player") then
								SLICECMDR.DPExpires = expirationTime1;
								SLICECMDR.BARS['DP']['Expires'] = expirationTime1;
								SLICECMDR.BARS['DP']['obj'].text2:SetText("x" .. string.format("%i", count1));
								SLICECMDR.BARS['DP']['obj']:Show();
								SliceCmdr_ChangeAnchor();--change les ancres
							end
						end
					end
					-- RUPTURE --
					if (spellName == SC_SPELL_RUP and SliceCmdr_Save.RupBarShow == true) then
						local name2, rank2, icon2, count2, debuffType2, duration2, expirationTime2, isMine2, isStealable2 = UnitDebuff("target", SC_SPELL_RUP);						
						if ( not(type == "SPELL_AURA_APPLIED") and not(type == "SPELL_AURA_REFRESH")) then
							--SLICECMDR.BARS['Rup']['obj'].text2:SetText(isMine2);
							--SLICECMDR.BARS['Rup']['obj']:Hide();
							--SLICECMDR.RupExpires = 0;
							--SLICECMDR.BARS['Rup']['Expires'] = 0;
						else
							if (isMine2 == "player") then
								SLICECMDR.RupExpires = expirationTime2;
								SLICECMDR.BARS['Rup']['Expires'] = expirationTime2;
								--SLICECMDR.BARS['Rup']['obj'].text2:SetText("Rupture");
								SLICECMDR.BARS['Rup']['obj']:Show();
								SliceCmdr_ChangeAnchor();
							end
						end
					end
				end
			end	
		end
	end
	
	if (event == "UNIT_COMBO_POINTS") then
		local unit = select(1, ...);
		if (unit and unit == "player") then 
			SliceCmdr_SetComboPts();
		end
	end
	if (event == "PLAYER_TARGET_CHANGED") then
		SliceCmdr_SetComboPts();
		SliceCmdr_TestTarget();
	end
end

function SliceCmdr_TestTarget()
	local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitDebuff("target", SC_SPELL_DP);
	if (SliceCmdr_Save.DPBarShow == true) then
		if not name then
			SLICECMDR.DPExpires = 0;
			SLICECMDR.BARS['DP']['Expires'] = 0;
			SLICECMDR.BARS['DP']['obj']:Hide();
		else
			if (isMine == "player") then
				SLICECMDR.DPExpires = expirationTime;
				SLICECMDR.BARS['DP']['Expires'] = expirationTime;
 				SLICECMDR.BARS['DP']['obj'].text2:SetText(expirationTime);
				SLICECMDR.BARS['DP']['obj'].text:SetText("x" .. string.format("%i", count));
				SLICECMDR.BARS['DP']['obj']:Show();
			else
				SLICECMDR.DPExpires = 0;
				SLICECMDR.BARS['DP']['Expires'] = 0;
				SLICECMDR.BARS['DP']['obj']:Hide();
			end
		end
	end
	
	if (SliceCmdr_Save.RupBarShow == true) then	
		name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitDebuff("target", SC_SPELL_RUP);
		if not name then
			SLICECMDR.RupExpires = 0;
			SLICECMDR.BARS['Rup']['Expires'] = 0;
			SLICECMDR.BARS['Rup']['obj']:Hide();
			SliceCmdr_ChangeAnchor();--change les ancres
		else
			if (isMine == "player") then
				SLICECMDR.RupExpires = expirationTime;
				SLICECMDR.BARS['Rup']['Expires'] = expirationTime;
				--SLICECMDR.BARS['Rup']['obj'].text2:SetText("Rupture");
				SLICECMDR.BARS['Rup']['obj']:Show();
				SliceCmdr_ChangeAnchor();--change les ancres
			else
				SLICECMDR.RupExpires = 0;
				SLICECMDR.BARS['Rup']['Expires'] = 0;
				SLICECMDR.BARS['Rup']['obj']:Hide();
				SliceCmdr_ChangeAnchor();--change les ancres
			end
		end
	end		
end

local curCombo = 0

function SliceCmdr_SetComboPts()
	local points = GetComboPoints("player");
	if (SliceCmdr_Save.CPBarShow == true) then 
		if points == curCombo then
			if curCombo == 0 and not incombat and visible then
				UIFrameFadeOut(SLICECMDR.BARS['CP']['obj'], framefadeout);
				visible = false;
			elseif curCombo > 0 and not visible then
				UIFrameFadeIn(SLICECMDR.BARS['CP']['obj'], framefadein);
				visible = true;
			end
			return
		end
		
		if (points > curCombo) then
			for i = curCombo + 1, points do
				SLICECMDR.BARS['CP']['obj'].combos[i]:Show();
			end
			SliceCmdr_Combo:SetText(points);
		else
			for i = points + 1, curCombo do
				SLICECMDR.BARS['CP']['obj'].combos[i]:Hide();
			end
			SliceCmdr_Combo:SetText("");
		end	

		
		if points > 0 then
			SLICECMDR.BARS['CP']['obj'].comboText:SetText(points);
		else
			SLICECMDR.BARS['CP']['obj'].comboText:SetText("");
		end
		
		curCombo = points;
		
		if curCombo == 0 and not incombat and visible then
			UIFrameFadeOut(SLICECMDR.BARS['CP']['obj'], framefadeout);
			visible = false;
		elseif curCombo > 0 and not visible then
			UIFrameFadeIn(SLICECMDR.BARS['CP']['obj'], framefadein);
			visible = true;
		end
	else
		if (points > curCombo) then
			SliceCmdr_Combo:SetText(points);
		else
			SliceCmdr_Combo:SetText("");
		end	
	end		
end

function SliceCmdr_Unload()
	SliceCmdr:UnregisterAllEvents();
	SliceCmdr:Hide();
end

			
function SliceCmdr_NewFrame()
	local f = CreateFrame("StatusBar", nil, UIParent);
	
	f:SetWidth(widthUI);
	f:SetScale(scaleUI);
	f:SetHeight(10);
	f:SetPoint("TOPLEFT", VTimerEnergy, "BOTTOMLEFT", 0, -2);
	f:SetStatusBarTexture(SliceCmdr_BarTexture());
	f:SetStatusBarColor(0.768627451, 0, 0, 1);
	f:EnableMouse(false);
	f:SetMinMaxValues(0, 6.0);
	f:SetValue(0);

	f:Hide();
	
	f:SetBackdrop({
		  bgFile="Interface\\AddOns\\SliceCommander\\Images\\winco_stripe_128.tga",
		  edgeFile="",
		  tile=true, tileSize=1, edgeSize=0,
		  insets={left=-1, right=-1, top=-1, bottom=-3}
		});
	f:SetBackdropBorderColor(1,1,1,1);
	f:SetBackdropColor(0,0,0,0.5);
	
	-- text on the right --			
	if not f.text then
		f.text = f:CreateFontString(nil, nil, "GameFontWhite")
	end
	f.text:SetFontObject(SLICECMDR.BarFont2);
	f.text:SetHeight(10)
	f.text:SetWidth(30);
	f.text:SetPoint("TOPRIGHT", f, "TOPRIGHT",  -5, 0);
	f.text:SetJustifyH("RIGHT")
	f.text:SetText("");
	
	-- icon on the left --	
	if not f.icon then
		f.icon = f:CreateTexture(nil, "OVERLAY");
	end
	f.icon:SetHeight(f:GetHeight());
	f.icon:SetWidth(f.icon:GetHeight());
	f.icon:SetPoint("TOPLEFT", f, "TOPLEFT", 1, -1);
	f.icon:SetBlendMode("ADD");
	f.icon:SetAlpha(0.6);
	
	-- text on the left --
	if not f.text2 then
		f.text2 = f:CreateFontString(nil, nil, nil)
	end
	f.text2:SetFontObject(SLICECMDR.BarFont2);
	f.text2:SetHeight(10)
	f.text2:SetWidth(60);
	f.text2:SetPoint("TOPLEFT", f, "TOPLEFT",  f.icon:GetWidth() + SliceCmdr_Save.BarMargin + 1, 0);
	f.text2:SetJustifyH("LEFT")
	f.text2:SetText("");
	
	return f;
	
end

function SliceCmdr_CPFrame()
	local f = CreateFrame("StatusBar", nil, UIParent);
	local width = widthUI;
	--[[naiComboBar]]
	f:ClearAllPoints();
	f:SetWidth(width);
	f:SetScale(scaleUI);
	f:SetHeight(10)
	f:SetPoint("BOTTOMLEFT", VTimerEnergy, "TOPLEFT", 0, 3)
	
	f.bg = f:CreateTexture(nil, "BACKGROUND")
	f.bg:ClearAllPoints()
	--f.bg:SetAllPoints(f)
	f.bg:SetPoint("TOPLEFT", f, "TOPLEFT", -2, 2)
	f.bg:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", 2, -2)
	f.bg:SetTexture(SliceCmdr_BarTexture())
	f.bg:SetVertexColor(0.3, 0.3, 0.3)
	f.bg:SetAlpha(0.7)
	
	f.combos = {}
	
	local cx = 0
	local spacing = 3;
	width = ((width-(spacing*4))/5);
	
	-- text
	local font = "Fonts\\FRIZQT__.TTF"
	local fontsize = 13
	local fontstyle = "OUTLINE"
	
	for i = 1, 5 do
		local combo = CreateFrame("Frame", nil, f)
		combo:ClearAllPoints()
		combo:SetPoint("TOPLEFT", f, "TOPLEFT", cx, 0)
		combo:SetPoint("BOTTOMRIGHT", f, "BOTTOMLEFT", cx + width, 0)
		--combo:SetFrameStrata("HIGH")
		combo.bg = combo:CreateTexture(nil, "BACKGROUND")
		combo.bg:ClearAllPoints()
		combo.bg:SetAllPoints(combo)
		combo.bg:SetTexture(SliceCmdr_BarTexture())
		combo.bg:SetVertexColor(1, 0.86, 0.1)
		combo.bg:SetAlpha(1)
		combo:Hide()
		--combo:hide
		f.combos[i] = combo
		
		cx = cx + width + spacing
	end

	f.overlay = CreateFrame("Frame", nil, f)
	f.overlay:ClearAllPoints()
	f.overlay:SetAllPoints(f)
	f.comboText = f.overlay:CreateFontString(nil, "OVERLAY")
	f.comboText:SetFont(font, fontsize, fontstyle)
	f.comboText:SetShadowOffset(1, -1)
	f.comboText:SetShadowColor(0, 0, 0, 1)
	f.comboText:SetJustifyH("CENTER")
	f.comboText:ClearAllPoints()
	f.comboText:SetAllPoints(f.overlay)
	--f.comboText:SetText("5")

	visible = false
	f:Hide();
	--[[naiComboBar]]
	return f;
	
end

			
function SliceCmdr_OnLoad()
	local localizedClass, englishClass = UnitClass("player");
	if (englishClass == "ROGUE") then
		SliceCmdr:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
		SliceCmdr:RegisterEvent("UNIT_COMBO_POINTS");
		SLICECMDR.BarFont = CreateFont("VTimerFont");
		SLICECMDR.BarFont:SetFont("Fonts\\FRIZQT__.TTF", 12);
		SLICECMDR.BarFont:SetShadowColor(0,0,0, 0.7);
		SLICECMDR.BarFont:SetTextColor(1,1,1,1);
		SLICECMDR.BarFont:SetShadowOffset(0.8, -0.8);
		
		SLICECMDR.BarFont2 = CreateFont("VTimerFont2");
		SLICECMDR.BarFont2:SetFont("Fonts\\FRIZQT__.TTF", 8)
		SLICECMDR.BarFont2:SetShadowColor(0,0,0, 0.7);
		SLICECMDR.BarFont2:SetTextColor(213/255,200/255,184/255,1);
		SLICECMDR.BarFont2:SetShadowOffset(0.8, -0.8);
		
		SLICECMDR.BarFont3 = CreateFont("VTimerFont1O");
		SLICECMDR.BarFont3:SetFont("Fonts\\FRIZQT__.TTF", 12);
		SLICECMDR.BarFont3:SetShadowColor(0,0,0, 0.2);
		SLICECMDR.BarFont3:SetTextColor(0,0,0,1);
		SLICECMDR.BarFont3:SetShadowOffset(0.8, -0.8);
		
		SLICECMDR.BarFont4 = CreateFont("VTimerFont4");
		SLICECMDR.BarFont4:SetFont("Fonts\\FRIZQT__.TTF", 8)
		SLICECMDR.BarFont4:SetShadowColor(0,0,0, 0.7);
		--SLICECMDR.BarFont4:SetTextColor(213/255,200/255,184/255,1);
		SLICECMDR.BarFont3:SetTextColor(0,0,0,1);
		SLICECMDR.BarFont4:SetShadowOffset(0.8, -0.8);
		
		SLICECMDR.LastEnergy = UnitMana('player');
		
		VTimerEnergyTxt:SetFontObject(SLICECMDR.BarFont);
		--VTimerEnergyTxt:SetShadowColor(0,0,0);
		SliceCmdr_Combo:SetFontObject(SLICECMDR.BarFont3);
		
		VTimerEnergy:SetMinMaxValues(0,UnitManaMax("player"));
		VTimerEnergy:SetBackdrop({
		  bgFile="Interface\\AddOns\\SliceCommander\\Images\\winco_stripe_128.tga",
		  edgeFile="",
		  tile=true, tileSize=1, edgeSize=0,
		  insets={left=-1, right=-1, top=-1, bottom=0}
		});
		--"Interface\\TargetingFrame\\UI-StatusBar"
		VTimerEnergy:SetBackdropBorderColor(1,1,1,1);
		VTimerEnergy:SetBackdropColor(0,0,0,0.2);
		VTimerEnergy:SetStatusBarTexture(SliceCmdr_BarTexture());
		VTimerEnergy:SetWidth(200);
		--234,178,57
		VTimerEnergy:SetStatusBarColor(254/255, 246/255, 226/255);
		
		scaleUI = VTimerEnergy:GetScale();
		widthUI = VTimerEnergy:GetWidth();
		
		SLICECMDR.BARS['CP']['obj'] = SliceCmdr_CPFrame();

		SLICECMDR.BARS['SnD']['obj'] = SliceCmdr_NewFrame();
		SLICECMDR.BARS['SnD']['obj']:SetStatusBarColor(255/255, 74/255, 18/255, 0.9);
		SLICECMDR.BARS['SnD']['obj'].icon:SetTexture("Interface\\Icons\\Ability_Rogue_SliceDice");
		
		SLICECMDR.BARS['Rup']['obj'] = SliceCmdr_NewFrame();
		SLICECMDR.BARS['Rup']['obj']:SetStatusBarColor(130/255, 15/255, 0);
		SLICECMDR.BARS['Rup']['obj'].text2:SetFontObject(SLICECMDR.BarFont4);
		SLICECMDR.BARS['Rup']['obj'].icon:SetTexture("Interface\\Icons\\Ability_Rogue_Rupture");

		SLICECMDR.BARS['HfB']['obj'] = SliceCmdr_NewFrame();
		SLICECMDR.BARS['HfB']['obj']:SetStatusBarColor(104/255, 98/255, 100/255);		
		SLICECMDR.BARS['HfB']['obj'].icon:SetTexture("Interface\\Icons\\Ability_Rogue_HungerforBlood");
		
		SLICECMDR.BARS['DP']['obj'] = SliceCmdr_NewFrame();
		SLICECMDR.BARS['DP']['obj']:SetStatusBarColor(96/255, 116/255, 65/255);
		SLICECMDR.BARS['DP']['obj'].text2:SetFontObject(SLICECMDR.BarFont4);
		SLICECMDR.BARS['DP']['obj'].icon:SetTexture("Interface\\Icons\\Ability_Rogue_DualWeild");

		SliceCmdr_OnUpdate();
	else
		SliceCmdr_Unload();
		return;
	end
	
end

function SliceCmdr_util_SnDBuffTime()
	if ((SLICECMDR.SliceExpires > 0) and (SLICECMDR.tNow < SLICECMDR.SliceExpires)) then
		return SLICECMDR.SliceExpires - SLICECMDR.tNow;
	else
		return 0;
	end
end

function SliceCmdr_util_HungerTime()
	if ((SLICECMDR.HungerExpires > 0) and (SLICECMDR.tNow < SLICECMDR.HungerExpires)) then
		return SLICECMDR.HungerExpires - SLICECMDR.tNow;
	else
		return 0;
	end
end

function SliceCmdr_util_DPTime()
	if ((SLICECMDR.DPExpires > 0) and (SLICECMDR.tNow < SLICECMDR.DPExpires)) then
		return SLICECMDR.DPExpires - SLICECMDR.tNow;
	else
		return 0;
	end
end

function SliceCmdr_util_RupTime()
	if ((SLICECMDR.RupExpires > 0) and (SLICECMDR.tNow < SLICECMDR.RupExpires)) then
		return SLICECMDR.RupExpires - SLICECMDR.tNow;
	else
		return 0;
	end
end

function SliceCmdr_RupBar()
	local x = SliceCmdr_util_RupTime();
	
	--gw_print(x);
	if (x > 0) then
		if (SLICECMDR.BARS['Rup']) then
			SLICECMDR.BARS['Rup']['obj']:SetValue(x);
			SLICECMDR.BARS['Rup']['obj'].text:SetText(string.format("%0.1f", x));
		end
	else
		if (x == 0) then
			SLICECMDR.BARS['Rup']['obj'].text2:SetText(isMine2);
			SLICECMDR.BARS['Rup']['obj']:Hide();
			SLICECMDR.RupExpires = 0;
			SLICECMDR.BARS['Rup']['Expires'] = 0;
		end
	end	
	
end

function SliceCmdr_DPBar()
	local x = SliceCmdr_util_DPTime();
	
	--gw_print(x);
	if (x > 0) then
		if (SLICECMDR.BARS['DP']) then
			SLICECMDR.BARS['DP']['obj']:SetValue(x);
			SLICECMDR.BARS['DP']['obj'].text:SetText(string.format("%0.1f", x));
		end
	end
	if (x == 0) then
		SLICECMDR.DPExpires = 0;
		SLICECMDR.BARS['DP']['Expires'] = 0;
		SLICECMDR.BARS['DP']['obj']:Hide();
		--SlinceCmdr_ChangeAnchor();--change les ancres
	end
end

function SliceCmdr_HungerBar()
	local x = SliceCmdr_util_HungerTime();
	local hfb = SLICECMDR.BARS['HfB'];
	
	--gw_print(x);
	if (x > 0) then
		if (SLICECMDR.BARS['HfB']) then
			SLICECMDR.BARS['HfB']['obj']:SetValue(x);
			SLICECMDR.BARS['HfB']['obj'].text:SetText(string.format("%0.1f", x));
		end
		
		if (x <= 3) then
			if (hfb.AlertPending == 3) then
				SliceCmdr_Sound('HfB.Alert');
				hfb.AlertPending = 2;
			else 
				if (x <= 2) then
					if (hfb.AlertPending == 2) then
						SliceCmdr_Sound('HfB.Alert');
						hfb.AlertPending = 1;
					else 
						if (x <= 1) then
							if (hfb.AlertPending == 1) then
								SliceCmdr_Sound('HfB.Alert');
								hfb.AlertPending = 0;
							end
						end
					end
				end
			end
		else
			hfb.AlertPending = 3;
		end
		
	end	
	
end

function SliceCmdr_SNDCooldown() 
	SLICECMDR.tNow = GetTime();
	if (SliceCmdr_Save.PadLatency) then
		local down, up, lag = GetNetStats();
		SLICECMDR.tNow = SLICECMDR.tNow + (lag*2/1000);
	end	
		
	local x = SliceCmdr_util_SnDBuffTime();

	if (x > 0) then
		if (x <= 3) then
			if (SLICECMDR.AlertPending == 3) then
				SliceCmdr_Sound("Tick3");
				SLICECMDR.AlertPending = 2;
			else 
				if (x <= 2) then
					if (SLICECMDR.AlertPending == 2) then
						SliceCmdr_Sound("Tick2");
						SLICECMDR.AlertPending = 1;
					else 
						if (x <= 1) then
							if (SLICECMDR.AlertPending == 1) then
								SliceCmdr_Sound("Tick1");
								SLICECMDR.AlertPending = 0;
							end
						end
					end
				end
			end
		else
			SLICECMDR.AlertPending = 3;
		end
		
	end
	
	if (SLICECMDR.BARS['SnD']) then
		if (SLICECMDR.BARS['SnD']['obj']) then
			SLICECMDR.BARS['SnD']['obj']:SetValue(x);
			if (x > 0) then
				SLICECMDR.BARS['SnD']['obj'].text:SetText(string.format("%0.1f", x));
			else
				SLICECMDR.BARS['SnD']['obj'].text:SetText("");
			end		
		end			
	end
end

function SliceCmdr_OnUpdate()
	VTimerEnergy:SetValue(UnitMana("player"));
	VTimerEnergy:SetMinMaxValues(0,UnitManaMax("player"));
	
	if (UnitManaMax("player") == UnitMana('player')) then
		VTimerEnergyTxt:SetText("");
	else
		VTimerEnergyTxt:SetText(UnitMana("player"));
	end			
	
	SliceCmdr_Config_OtherVars();
	
	if (SLICECMDR.LastEnergy < UnitMana('player')) then
		if ((SLICECMDR.LastEnergy < SliceCmdr_Save.Energy2) and (UnitMana('player') >= SliceCmdr_Save.Energy2)) then
			SliceCmdr_Sound("EnergySound2");
		else
			if ((SLICECMDR.LastEnergy < SliceCmdr_Save.Energy1) and (UnitMana('player') >= SliceCmdr_Save.Energy1)) then
				SliceCmdr_Sound("EnergySound1");
			end
		end
		if (UnitManaMax("player") == UnitMana('player')) then
			--VTimerEnergy:Hide();
			VTimerEnergy:SetAlpha(SliceCmdr_Save.EnergyTrans / 100.0);
		else
			--VTimerEnergy:Show();
			VTimerEnergy:SetAlpha(1.0);
		end
	end
	
	SLICECMDR.LastEnergy = UnitMana('player');
	SliceCmdr_SNDCooldown();
	SliceCmdr_HungerBar();
	SliceCmdr_DPBar();
	SliceCmdr_RupBar();
end